using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ibba.agil.core;
using ibba.agil.core.common;
using ibba.agil.manager;

namespace ibba.agil.data
{
    public class tbagi010TipoCamo_ENT : EntityData, IDataEntity
    {
        private tbagi010TipoCamo_MNG _manager;

        #region Data

        public string codTipoCamo { get; set; }
        public string desTipoCamo { get; set; }


        #endregion

        /// <summary>
        /// Construtor necessario para configura��o dos mapeamentos :: Entidade < -- > TABELA
        /// </summary>
        public tbagi010TipoCamo_ENT()
        {
            // determina o mapeamento entre a tabela e entidade
            base.MapperTable = new Dictionary<string, string>() { { this.GetType().Name, "TBAGI010_TIPO_CAMO" } };

            // determina o mapeamento entre a coluna da tabela e propriedade
            base.Mapper = new Dictionary<string, string>() { 
                     {"codTipoCamo", "COD_TIPO_CAMO"    }, 
                     {"desTipoCamo", "DES_TIPO_CAMO"    }          
            };

            // determina o mapeamento das chaves
            base.MapperKeys = new Dictionary<string, string>() { 
                    //DictionaryEntityKey//
                    {"codTipoCamo", "COD_TIPO_CAMO"    }
            };

            // determina se a chave � identity
            base.MapperKeyIsNotIdentity = true;

            // instancia o manager
            _manager = new tbagi010TipoCamo_MNG();
        }

        public override void Save()
        {
            _manager.Save(this);
        }

        public override void Save(TransactionManager transactionContext)
        {
            _manager.Save(this, transactionContext);
        }

        public override void Delete()
        {
            _manager.Delete(this);
        }

        public override void Delete(TransactionManager transactionContext)
        {
            _manager.Delete(this);
        }
    }
}
