﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ibba.agil.core;
using ibba.agil.core.common;

namespace ibba.agil.data.data
{
    public class tbagi012TipoLayo_ENT : EntityData, IDataEntity
    {
        private manager.tbagi012TipoLayo_MNG _manager;

        #region Data

        public String codTipoLayo { get; set; }
        public String desTipoLayo { get; set; }

        #endregion
     
        /// <summary>
        /// Construtor necessario para configuração dos mapeamentos :: Entidade < -- > TABELA
        /// </summary>
        public tbagi012TipoLayo_ENT()
        {
            // determina o mapeamento entre a tabela e entidade
            base.MapperTable = new Dictionary<string, string>() { { this.GetType().Name, "dbo.TBAGI012_TIPO_LAYO" } };

            // determina o mapeamento entre a coluna da tabela e propriedade
            base.Mapper = new Dictionary<string, string>() { 
                     {"codTipoLayo", "COD_TIPO_LAYO"  },     
                     {"desTipoLayo", "DES_TIPO_LAYO"  }                 
            };

            // determina o mapeamento das chaves
            base.MapperKeys = new Dictionary<string, string>() { 
                     {"codTipoLayo", "COD_TIPO_LAYO"}
            };

            // determina se a chave é identity
            base.MapperKeyIsNotIdentity = true;

            // instancia o manager
            _manager = new manager.tbagi012TipoLayo_MNG();
        }

        public override void Save()
        {
            _manager.Save(this);
        }

        public override void Save(TransactionManager transactionContext)
        {
            _manager.Save(this, transactionContext);
        }

        public override void Delete()
        {
            _manager.Delete(this);
        }

        public override void Delete(TransactionManager transactionContext)
        {
            throw new NotImplementedException();
        }
    }
}
